/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : NetOptim                                                    */
/*    Fichier : struct.h                                                    */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Vincent POUILLEY                      le : 12/11/1991     */
/*                                                                          */
/*    Modifie par : V. POUILLEY                         le : 11/05/1992     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/

/* stucture arete */
typedef struct t_arete
{
	float capa;
	int R;
	int tpxx;
	struct t_noeud * source;
	struct t_noeud * dest;
	locon_list * locon;
} t_arete;

/* structure noeud */
typedef struct t_noeud
{
	char niveau;
	int recursion;
	float totcapa;
	int temps;
	int slack;
	losig_list * losig;
	loins_list * loins;
	locon_list * locon;
	/* t_arete */chain_list * next;
	/* t_arete */chain_list * pred;
} t_noeud;

/* structure pour le tableau des entrees */
typedef struct t_tabentrees
{
	locon_list * locon;
	/* t_arete */chain_list * noeud1;
	/* t_arete */chain_list * noeud0;
	/* t_tabsortie */chain_list * sorties;
} t_tabentrees;

/* structure pour le tableau des sorties */
typedef struct t_tabsorties
{
	locon_list * locon;
	int temps_res;
	int temps_voulu;
	t_arete * noeud1;
	t_arete * noeud0;
	ptype_list * entrees;
} t_tabsorties;

